# -*- coding: utf-8 -*-

#Copyright (C) 2006 John 
#
#This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the #Free Software Foundation; either version 2 of the License, or (at your option) any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of #MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, #Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


from qt import *
import os
import urllib
import time
import tuner
import thread
import sys
import string

home=tuner.homevar()


class Main(QMainWindow):
     def __init__(self,parent = None,name = None,fl = 0):
	try: 
		os.mkdir(home+'/.tunapie')
        except OSError:
		pass
        QMainWindow.__init__(self,parent,name,fl)
        self.statusBar()

        if not name:
            self.setName("Main")

	self.image0 = QPixmap()
        self.image0.load("./icons/icon.xpm")
	self.setIcon(self.image0)
	
	
	self.setCentralWidget(QWidget(self,"qt_central_widget"))
        MainLayout = QGridLayout(self.centralWidget(),1,1,11,6,"MainLayout")

        layout21 = QVBoxLayout(None,0,6,"layout21")

        layout7 = QHBoxLayout(None,0,6,"layout7")

        self.textLabel1_2 = QLabel(self.centralWidget(),"textLabel1_2")
        self.textLabel1_2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1_2.sizePolicy().hasHeightForWidth()))
        layout7.addWidget(self.textLabel1_2)

        self.cmbSort = QComboBox(0,self.centralWidget(),"cmbSort")
        self.cmbSort.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.cmbSort.sizePolicy().hasHeightForWidth()))
        layout7.addWidget(self.cmbSort)

        self.rTV = QRadioButton(self.centralWidget(),"rTV")
        self.rTV.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.rTV.sizePolicy().hasHeightForWidth()))
        self.rTV.setChecked(1)
        layout7.addWidget(self.rTV)

        self.rRadio = QRadioButton(self.centralWidget(),"rRadio")
        self.rRadio.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.rRadio.sizePolicy().hasHeightForWidth()))
        layout7.addWidget(self.rRadio)
        spacer4 = QSpacerItem(21,21,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout7.addItem(spacer4)
        layout21.addLayout(layout7)

        self.listBox1 = QListBox(self.centralWidget(),"listBox1")
        self.listBox1.setSizePolicy(QSizePolicy(QSizePolicy.Minimum,QSizePolicy.Expanding,0,0,self.listBox1.sizePolicy().hasHeightForWidth()))
        layout21.addWidget(self.listBox1)

        self.groupBox1 = QGroupBox(self.centralWidget(),"groupBox1")
        self.groupBox1.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Fixed,0,0,self.groupBox1.sizePolicy().hasHeightForWidth()))
        self.groupBox1.setColumnLayout(0,Qt.Vertical)
        self.groupBox1.layout().setSpacing(6)
        self.groupBox1.layout().setMargin(11)
        groupBox1Layout = QVBoxLayout(self.groupBox1.layout())
        groupBox1Layout.setAlignment(Qt.AlignTop)

        layout20 = QHBoxLayout(None,0,6,"layout20")

        self.txtSearch = QLineEdit(self.groupBox1,"txtSearch")
        self.txtSearch.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Fixed,0,0,self.txtSearch.sizePolicy().hasHeightForWidth()))
        self.txtSearch.setFrameShape(QLineEdit.LineEditPanel)
        self.txtSearch.setFrameShadow(QLineEdit.Sunken)
        layout20.addWidget(self.txtSearch)

        self.btnGo = QPushButton(self.groupBox1,"btnGo")
        self.btnGo.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.btnGo.sizePolicy().hasHeightForWidth()))
        layout20.addWidget(self.btnGo)
        groupBox1Layout.addLayout(layout20)
        layout21.addWidget(self.groupBox1)

        MainLayout.addLayout(layout21,0,0)

        layout12 = QVBoxLayout(None,0,6,"layout12")

        layout11 = QVBoxLayout(None,0,6,"layout11")
        spacer2 = QSpacerItem(20,21,QSizePolicy.Minimum,QSizePolicy.Fixed)
        layout11.addItem(spacer2)

        self.groupBox2 = QGroupBox(self.centralWidget(),"groupBox2")
        self.groupBox2.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Fixed,0,0,self.groupBox2.sizePolicy().hasHeightForWidth()))
        self.groupBox2.setColumnLayout(0,Qt.Vertical)
        self.groupBox2.layout().setSpacing(6)
        self.groupBox2.layout().setMargin(11)
        groupBox2Layout = QVBoxLayout(self.groupBox2.layout())
        groupBox2Layout.setAlignment(Qt.AlignTop)

        layout7_2 = QHBoxLayout(None,0,6,"layout7_2")

        self.textLabel1_3 = QLabel(self.groupBox2,"textLabel1_3")
        self.textLabel1_3.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1_3.sizePolicy().hasHeightForWidth()))
        layout7_2.addWidget(self.textLabel1_3)

        self.txtplay = QLabel(self.groupBox2,"txtplay")
        self.txtplay.setSizePolicy(QSizePolicy(QSizePolicy.Ignored,QSizePolicy.Preferred,0,0,self.txtplay.sizePolicy().hasHeightForWidth()))
        txtplay_font = QFont(self.txtplay.font())
        txtplay_font.setPointSize(10)
        self.txtplay.setFont(txtplay_font)
        layout7_2.addWidget(self.txtplay)
        groupBox2Layout.addLayout(layout7_2)

        layout8 = QHBoxLayout(None,0,6,"layout8")

        self.textLabel1_3_2 = QLabel(self.groupBox2,"textLabel1_3_2")
        self.textLabel1_3_2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1_3_2.sizePolicy().hasHeightForWidth()))
        layout8.addWidget(self.textLabel1_3_2)

        self.txtgenre = QLabel(self.groupBox2,"txtgenre")
        self.txtgenre.setSizePolicy(QSizePolicy(QSizePolicy.Ignored,QSizePolicy.Preferred,0,0,self.txtgenre.sizePolicy().hasHeightForWidth()))
        layout8.addWidget(self.txtgenre)
        groupBox2Layout.addLayout(layout8)

        layout9 = QHBoxLayout(None,0,6,"layout9")

        self.textLabel1_3_2_2 = QLabel(self.groupBox2,"textLabel1_3_2_2")
        self.textLabel1_3_2_2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1_3_2_2.sizePolicy().hasHeightForWidth()))
        layout9.addWidget(self.textLabel1_3_2_2)

        self.txtlistener = QLabel(self.groupBox2,"txtlistener")
        self.txtlistener.setSizePolicy(QSizePolicy(QSizePolicy.Ignored,QSizePolicy.Preferred,0,0,self.txtlistener.sizePolicy().hasHeightForWidth()))
        layout9.addWidget(self.txtlistener)
        groupBox2Layout.addLayout(layout9)

        layout10 = QHBoxLayout(None,0,6,"layout10")

        self.textLabel1_3_2_2_2 = QLabel(self.groupBox2,"textLabel1_3_2_2_2")
        self.textLabel1_3_2_2_2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1_3_2_2_2.sizePolicy().hasHeightForWidth()))
        layout10.addWidget(self.textLabel1_3_2_2_2)

        self.txtbitrate = QLabel(self.groupBox2,"txtbitrate")
        self.txtbitrate.setSizePolicy(QSizePolicy(QSizePolicy.Ignored,QSizePolicy.Preferred,0,0,self.txtbitrate.sizePolicy().hasHeightForWidth()))
        layout10.addWidget(self.txtbitrate)
        groupBox2Layout.addLayout(layout10)

        layout12_2 = QHBoxLayout(None,0,6,"layout12_2")
	
	image=QPixmap("./icons/play.png")
        self.btnplay = QPushButton(QIconSet(image),"",self.groupBox2,"btnplay")
        self.btnplay.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.btnplay.sizePolicy().hasHeightForWidth()))
        layout12_2.addWidget(self.btnplay)

	image=QPixmap("./icons/add.png")
        self.btnadd = QPushButton(QIconSet(image),"",self.groupBox2,"btnadd")
        self.btnadd.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.btnadd.sizePolicy().hasHeightForWidth()))
        layout12_2.addWidget(self.btnadd)
        spacer4_2 = QSpacerItem(91,21,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout12_2.addItem(spacer4_2)
        groupBox2Layout.addLayout(layout12_2)
        layout11.addWidget(self.groupBox2)
        layout12.addLayout(layout11)

        self.groupBox3 = QGroupBox(self.centralWidget(),"groupBox3")
        self.groupBox3.setSizePolicy(QSizePolicy(QSizePolicy.Preferred,QSizePolicy.Preferred,0,0,self.groupBox3.sizePolicy().hasHeightForWidth()))
        self.groupBox3.setColumnLayout(0,Qt.Vertical)
        self.groupBox3.layout().setSpacing(6)
        self.groupBox3.layout().setMargin(11)
        groupBox3Layout = QVBoxLayout(self.groupBox3.layout())
        groupBox3Layout.setAlignment(Qt.AlignTop)

        self.lstfavorites = QListBox(self.groupBox3,"lstfavorites")
        self.lstfavorites.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,0,0,self.lstfavorites.sizePolicy().hasHeightForWidth()))
        self.lstfavorites.setHScrollBarMode(QListBox.AlwaysOff)
        groupBox3Layout.addWidget(self.lstfavorites)

        layout11_2 = QHBoxLayout(None,0,6,"layout11_2")
        spacer3 = QSpacerItem(171,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout11_2.addItem(spacer3)

	image=QPixmap("./icons/del.png")
        self.btnDelete = QPushButton(QIconSet(image),"",self.groupBox3,"btnDelete")
        layout11_2.addWidget(self.btnDelete)
        groupBox3Layout.addLayout(layout11_2)
        layout12.addWidget(self.groupBox3)

        MainLayout.addLayout(layout12,0,1)

        self.fileReloadAction = QAction(self,"fileReloadAction")
        self.filePreferencesAction = QAction(self,"filePreferencesAction")
        self.fileExitAction = QAction(self,"fileExitAction")
        self.fileAbout = QAction(self,"fileAbout")




        self.MenuBarEditor = QMenuBar(self,"MenuBarEditor")


        self.PopupMenuEditor = QPopupMenu(self)
        self.fileReloadAction.addTo(self.PopupMenuEditor)
        self.filePreferencesAction.addTo(self.PopupMenuEditor)
        self.fileExitAction.addTo(self.PopupMenuEditor)
        self.MenuBarEditor.insertItem(QString(""),self.PopupMenuEditor,1)

        self.unnamed = QPopupMenu(self)
        self.fileAbout.addTo(self.unnamed)
        self.MenuBarEditor.insertItem(QString(""),self.unnamed,2)


        self.languageChange()

        self.resize(QSize(649,464).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.listBox1,SIGNAL("clicked(QListBoxItem*)"),self.listBox1_clicked)
        self.connect(self.listBox1,SIGNAL("doubleClicked(QListBoxItem*)"),self.listBox1_doubleClicked)
        self.connect(self.btnplay,SIGNAL("clicked()"),self.btnplay_clicked)
        self.connect(self.btnadd,SIGNAL("clicked()"),self.btnadd_clicked)
        self.connect(self.btnGo,SIGNAL("clicked()"),self.btnGo_clicked)
        self.connect(self.fileReloadAction,SIGNAL("activated()"),self.fileReloadAction_activated)
        self.connect(self.listBox1,SIGNAL("selectionChanged(QListBoxItem*)"),self.listBox1_selectionChanged)
        self.connect(self.listBox1,SIGNAL("returnPressed(QListBoxItem*)"),self.listBox1_returnPressed)
        self.connect(self.lstfavorites,SIGNAL("doubleClicked(QListBoxItem*)"),self.lstfavorites_doubleClicked)
        self.connect(self.lstfavorites,SIGNAL("clicked(QListBoxItem*)"),self.lstfavorites_clicked)
        self.connect(self.lstfavorites,SIGNAL("selectionChanged(QListBoxItem*)"),self.lstfavorites_selectionChanged)
        self.connect(self.lstfavorites,SIGNAL("returnPressed(QListBoxItem*)"),self.lstfavorites_returnPressed)
        self.connect(self.rTV,SIGNAL("toggled(bool)"),self.rTV_toggled)
        self.connect(self.rRadio,SIGNAL("toggled(bool)"),self.rRadio_toggled)
        self.connect(self.fileExitAction,SIGNAL("activated()"),self.fileExitAction_activated)
        self.connect(self.fileAbout,SIGNAL("activated()"),self.fileAbout_activated)
        self.connect(self.filePreferencesAction,SIGNAL("activated()"),self.filePreferencesAction_activated)
        self.connect(self.cmbSort,SIGNAL("activated(int)"),self.cmbSort_activated)
        self.connect(self.txtSearch,SIGNAL("returnPressed()"),self.txtSearch_returnPressed)
        self.connect(self.btnDelete,SIGNAL("clicked()"),self.btnDelete_clicked)
	
	##################################################################
	
	self.tipo=0 # Tipo 0 Tv , 1 Radio
	self.slp=QWaitCondition() # wait thread
	self.FillStreams()#Fill Streams
	self.favoritos() # Fill Fav list
	self.downw=0 # Downloading Window
	##############

     def languageChange(self):
        self.setCaption(self.__tr("QTunapie"))
        self.textLabel1_2.setText(self.__tr("Sort By:"))
        self.cmbSort.clear()
        self.cmbSort.insertItem(self.__tr("Listeners"))
        self.cmbSort.insertItem(self.__tr("Name"))
        self.cmbSort.insertItem(self.__tr("Genre"))
        self.cmbSort.insertItem(self.__tr("Bitrate"))
        self.rTV.setText(self.__tr("TV"))
        self.rRadio.setText(self.__tr("Radio"))
        self.groupBox1.setTitle(self.__tr("Search"))
        self.btnGo.setText(self.__tr("Go"))
        self.groupBox2.setTitle(self.__tr("Stream Information"))
        self.textLabel1_3.setText(self.__tr("<b>Playing</b> :"))
        self.txtplay.setText(QString.null)
        self.textLabel1_3_2.setText(self.__tr("<b>Genre</b> :"))
        self.txtgenre.setText(QString.null)
        self.textLabel1_3_2_2.setText(self.__tr("<b>Listener</b> :"))
        self.txtlistener.setText(QString.null)
        self.textLabel1_3_2_2_2.setText(self.__tr("<b>Bitrate</b> :"))
        self.txtbitrate.setText(QString.null)
        self.btnplay.setText(self.__tr("Play"))
        self.btnadd.setText(self.__tr("Add"))
        self.groupBox3.setTitle(self.__tr("Favorites"))
        self.btnDelete.setText(self.__tr("Delete"))
        self.fileReloadAction.setText(self.__tr("Reload"))
        self.fileReloadAction.setMenuText(self.__tr("Reload"))
        self.filePreferencesAction.setText(self.__tr("Preferences"))
        self.filePreferencesAction.setMenuText(self.__tr("Preferences"))
        self.fileExitAction.setText(self.__tr("Exit"))
        self.fileExitAction.setMenuText(self.__tr("Exit"))
        self.fileAbout.setText(self.__tr("About"))
        self.fileAbout.setMenuText(self.__tr("About"))
        if self.MenuBarEditor.findItem(1):
            self.MenuBarEditor.findItem(1).setText(self.__tr("File"))
        if self.MenuBarEditor.findItem(2):
            self.MenuBarEditor.findItem(2).setText(self.__tr("Help"))


	    
     def FillStreams(self): # tipo 0 TV , tipo 1 Radio
	self.name=[] # Name of the stream
	self.url=[] # Url of the stream
	self.genre=[] # Genre of the stream
	self.playing=[] # Stream Playing
	self.bitrate=[] # Bitrate of the stream
	self.listeners=[] # listeners of the stream
	if (self.tipo==0): # Tipo 0 Tv , 1 Radio
		try :
		  self.url,self.name,self.genre,self.playing,self.bitrate,\
		  self.listeners=tuner.getlist(0) # Get TV file values
		except :
		  self.fileReloadAction_activated()
	if (self.tipo==1): # Tipo 0 Tv , 1 Radio
		try :
		  self.url,self.name,self.genre,self.playing,self.bitrate,\
		  self.listeners=tuner.getlist(1) # Get Radio file values
		except :
		  self.fileReloadAction_activated()
	self.listBox1.clear()
	self.listBox1.insertStrList(self.name)
     def listBox1_clicked(self,item):
        indice=self.listBox1.index(item)
	self.txtplay.setText(self.playing[indice])
	self.txtgenre.setText(self.genre[indice])
	self.txtlistener.setText(self.listeners[indice])
	self.txtbitrate.setText(self.bitrate[indice])
     def listBox1_doubleClicked(self,item):
	indice=self.listBox1.index(item)
	thread.start_new_thread(self.play_tv, ( indice, ))

     def btnplay_clicked(self):
        item=self.listBox1.selectedItem()
	indice=self.listBox1.index(item)
	print self.url[indice]
	thread.start_new_thread(self.play_tv, ( indice, )) # MultiThread support (multiples stremas open at the same time)
	
     def play_tv(self,indice): # Play TV Stream
	tuner.playvid(self.url[indice])
     def favplay_tv(self,indice): # Play FavTV Stream
	tuner.playvid(self.favurl[indice])
     def btnstop_clicked(self):
        thread.exit()
     def listBox1_selectionChanged(self,item):
	indice=self.listBox1.index(item)
	self.txtplay.setText(self.playing[indice])
	self.txtgenre.setText(self.genre[indice])
	self.txtlistener.setText(self.listeners[indice])
	self.txtbitrate.setText(self.bitrate[indice])
     def favoritos(self):
	self.favname=[] # Fav Name Stream
	self.favurl=[] # Fav Url Stream
	self.favmod=[] # False(0) TV , (1)True Radio 
	self.favlist=[] #Fav listeners of the stream
	self.favplay=[] # Fav Stream Playing
	self.favbit=[] # Fav Bitrate of the stream
	self.favgen=[] # Fav  Genre of the stream
	try:
	 self.favname,self.favurl,self.favgen,self.favplay,\
	 self.favbit,self.favlist,self.favmod=\
	 tuner.getlist(2) # Get Favorites file values
	except IOError:
	 pass
	self.lstfavorites.clear()
	self.lstfavorites.insertStrList(self.favname)
     def btnadd_clicked(self): # Add Fav
	item=self.listBox1.selectedItem()
	indice=self.listBox1.index(item)
        self.favname.append(self.name[indice])
        self.favurl.append(self.url[indice])
	self.favmod.append(self.tipo) # Tipo 0 Tv , 1 Radio
        self.favplay.append(self.playing[indice])
        self.favbit.append(self.bitrate[indice])
        self.favgen.append(self.genre[indice])
        self.favlist.append(self.listeners[indice])
	#Sav Fav to file
	tuner.savefavorites(self.favname,self.favurl,self.favlist,\
	self.favplay,self.favbit,self.favgen,self.favmod)
	self.favoritos()
     def btnrecord_clicked(self):# Record stream
	item=self.listBox1.selectedItem()
	indice=self.listBox1.index(item)
	self.recordselection(self.url[indice])
	#thread.start_new_thread(self.recordselection , (self.url[indice] , ))
     def txtSearch_returnPressed(self):
	self.btnGo_clicked()
     def btnGo_clicked(self): # Search
	search= self.txtSearch.text()  # QString object
	search=search.lower()
	search=search.stripWhiteSpace()
	newname=[] 
	newgenre=[]
	newplaying=[]
	newlisteners=[]
	newbitrate=[]     
	newurl=[] 
	i=0
	for name in self.name:
		name=name.lower() # string from a list
		if name.find(str(search))>-1:
			newname.append(self.name[i])
			newgenre.append(self.genre[i])
			newplaying.append(self.playing[i])
			newlisteners.append(self.listeners[i])
			newbitrate.append(self.bitrate[i])
			newurl.append(self.url[i]) 
		i=i+1
	self.name=newname
	self.genre=newgenre
	self.playing=newplaying
	self.listeneres=newlisteners
	self.bitrate=newbitrate
	self.url=newurl
	del newname
	del newgenre
	del newplaying
	del newlisteners
	del newbitrate
	del newurl
	self.listBox1.clear()
	self.listBox1.insertStrList(self.name)
     def fileReloadAction_activated(self):
        self.ste=1 # status of the thread
	thread.start_new_thread(self.reload, ())
	self.downw=Download(self)
	self.downw.show()
	thread.start_new_thread(self.showDialogo, (self.downw , ))
	   
     def Fill(self):# tipo 0 TV , tipo 1 Radio
	self.listBox1.clear()
	self.name=[] # Name of the stream
	self.url=[] # Url of the stream
	self.genre=[] # Genre of the stream
	self.playing=[] # Stream Playing
	self.bitrate=[] # Bitrate of the stream
	self.listeners=[] # listeners of the stream
	if (self.tipo==0): # Tipo 0 Tv , 1 Radio
		try :
		  self.url,self.name,self.genre,self.playing,self.bitrate,\
		  self.listeners=tuner.getlist(0) # Get TV file values
		except :
		  pass
	if (self.tipo==1): # Tipo 0 Tv , 1 Radio
		try :
		  self.url,self.name,self.genre,self.playing,self.bitrate,\
		  self.listeners=tuner.getlist(1) # Get Radio file values
		except :
		  pass
	self.listBox1.insertStrList(self.name)
     def showDialogo(self,a):
	qApp.lock() # Lock app for crashing ...
	while (self.ste==1):
	  self.slp.wait(100) # wait thread to end
	self.slp.wakeAll()
	qApp.unlock()# Unlock
	a.reject()
	self.Fill()
	return
     def serror(self):
	     QMessageBox.warning(self,self.__tr("Warning"),self.__tr("Can't Access to Server"))
     def reload (self):
	if (self.tipo==0): # Tipo 0 Tv , 1 Radio
	     tuner.writetvxml()
	if (self.tipo==1): # Tipo 0 Tv , 1 Radio
	     tuner.writeradioxml()
	print "Done"
	self.ste=0 # Threat Finished
	return
     def proceso_read(self): # leer proceso
	while ( self.proceso.canReadLineStdout() ):
		print self.proceso.readLineStdout()
     def proceso_error(self): #Error en el proceso
    	print self.proceso.readStderr()
     def listBox1_returnPressed(self,item):
        indice=self.listBox1.index(item)
	thread.start_new_thread(self.play_tv, ( indice, ))
     def lstfavorites_doubleClicked(self,item):
	indice=self.lstfavorites.index(item)
	thread.start_new_thread(self.favplay_tv, ( indice, ))

     def lstfavorites_clicked(self,item):
	indice=self.lstfavorites.index(item)
	self.txtplay.setText(self.favplay[indice])
	self.txtgenre.setText(self.favgen[indice])
	self.txtlistener.setText(self.favlist[indice])
	self.txtbitrate.setText(self.favbit[indice])

     def lstfavorites_selectionChanged(self,item):
        indice=self.lstfavorites.index(item)
	self.txtplay.setText(self.favplay[indice])
	self.txtgenre.setText(self.favgen[indice])
	self.txtlistener.setText(self.favlist[indice])
	self.txtbitrate.setText(self.favbit[indice])

     def lstfavorites_returnPressed(self,a0):
        indice=self.lstfavorites.index(a0)
	thread.start_new_thread(self.favplay_tv, ( indice, ))

     def cmbSort_activated(self,a0): #Sort 0 -Listeners, 1-Name , 2-Genre , 3-Bitrate
	self.listBox1.clear()
	
	if (a0==3): # Bitrate
		bitratenew=[]
            	for i in self.bitrate:
                	bitratenew.append(int(i))
            	self.bitrate=bitratenew
		del bitratenew
	        directory=zip(self.bitrate, self.listeners,  self.genre, self.name,self.url, self.playing)
		directory.sort()
		directory.reverse()
		self.name = []# Name of the stream    del self.name 
		self.url=[] # Url of the stream
		self.genre=[] # Genre of the stream
		self.playing=[] # Stream Playing
		self.bitrate=[] # Bitrate of the stream
		self.listeners=[] # listeners of the stream
		for i in directory:
			self.bitrate.append(str(i[0]))
			self.listeners.append(i[1])
			self.genre.append(i[2])
			self.name.append(i[3])
			self.url.append(i[4])
			self.playing.append(i[5])
	if (a0==2): # Genre
	       directory=zip(self.genre, self.listeners,  self.name, self.bitrate,self.url, self.playing)
               directory.sort()
               self.listeners,self.genre,self.bitrate,self.url,self.playing, self.name=[],[],[],[],[],[]
               for i in directory:
			self.genre.append(i[0])
			self.listeners.append(i[1])
			self.name.append(i[2])
			self.bitrate.append(i[3])
			self.url.append(i[4])
			self.playing.append(i[5])	
	if (a0==0): # Listeners
		listenersnew=[]
            	for i in self.listeners:
                	listenersnew.append(int(i))
                self.listeners=listenersnew
	        del listenersnew
	        directory=zip(self.listeners,self.genre,self.name, self.bitrate,self.url, self.playing)
                directory.sort()
	        directory.reverse()
                self.listeners,self.genre,self.bitrate,self.url,self.playing, self.name=[],[],[],[],[],[]
                for i in directory:
			self.listeners.append(str(i[0]))
			self.genre.append(i[1])
			self.name.append(i[2])
			self.bitrate.append(i[3])
			self.url.append(i[4])
			self.playing.append(i[5])	
	if(a0==1): # Name
	      directory=zip(self.name, self.listeners,  self.genre, self.bitrate,self.url, self.playing)
              directory.sort()
              self.listeners,self.genre,self.bitrate,self.url,self.playing,self.name=[],[],[],[],[],[]
              for i in directory:
			self.name.append(i[0])
			self.listeners.append(i[1])
			self.genre.append(i[2])
			self.bitrate.append(i[3])
			self.url.append(i[4])
			self.playing.append(i[5])
	self.listBox1.insertStrList(self.name)

     def rTV_toggled(self,act):
	if (act==True):
		self.rRadio.setChecked(False)
		self.tipo=0
		self.fileReloadAction_activated()

     def rRadio_toggled(self,act):
        if (act==True):
		self.rTV.setChecked(False)
		self.tipo=1
		self.fileReloadAction_activated()
		
     def fileExitAction_activated(self): # Exit QTunapie
        sys.exit()

     def fileAbout_activated(self):
        a=About(self)
	a.show()
	
     def filePreferencesAction_activated(self):
	a=Preferences(self)
	a.show()
     
     def btnDelete_clicked(self): # Delete Favorite
	favindice=self.lstfavorites.currentItem()
	del self.favname[favindice]
	del self.favurl[favindice]
	del self.favmod[favindice]
	del self.favlist[favindice]
	del self.favplay[favindice]
	del self.favbit[favindice]
	del self.favgen[favindice]
	self.lstfavorites.removeItem(favindice)
        tuner.savefavorites(self.favname,self.favurl,self.favlist,\
	self.favplay,self.favbit,self.favgen,self.favmod)  # Save Favorites
     def __tr(self,s,c = None):
        return qApp.translate("Main",s,c)

class Download(QDialog):
    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QDialog.__init__(self,parent,name,modal,Qt.WStyle_Customize | Qt.WStyle_DialogBorder)

        self.image0 = QPixmap()
	self.image0.load("./icons/icon.xpm")
        if not name:
            self.setName("Download")

        self.setEnabled(1)
        self.setSizePolicy(QSizePolicy(QSizePolicy.Minimum,QSizePolicy.Minimum,0,0,self.sizePolicy().hasHeightForWidth()))

        DownloadLayout = QHBoxLayout(self,11,6,"DownloadLayout")

        layout2 = QHBoxLayout(None,0,6,"layout2")

        self.pixmapLabel1 = QLabel(self,"pixmapLabel1")
        self.pixmapLabel1.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.pixmapLabel1.sizePolicy().hasHeightForWidth()))
        self.pixmapLabel1.setPixmap(self.image0)
        self.pixmapLabel1.setScaledContents(1)
        layout2.addWidget(self.pixmapLabel1)

        self.textLabel1 = QLabel(self,"textLabel1")
        self.textLabel1.setSizePolicy(QSizePolicy(QSizePolicy.Preferred,QSizePolicy.Preferred,0,0,self.textLabel1.sizePolicy().hasHeightForWidth()))
        layout2.addWidget(self.textLabel1)
        DownloadLayout.addLayout(layout2)

        self.languageChange()

        self.resize(QSize(215,60).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)


    def languageChange(self):
        self.setCaption(self.__tr("Downloading"))
        self.textLabel1.setText(self.__tr("<b>Retrieving list ...</b>"))


    def __tr(self,s,c = None):
        return qApp.translate("Download",s,c)

class About(QDialog):
    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QDialog.__init__(self,parent,name,modal,fl)

        self.image0 = QPixmap()
	
        self.image0.load("./icons/icon.png")
        if not name:
            self.setName("About")
	    
        AboutLayout = QGridLayout(self,1,1,11,6,"AboutLayout")

        layout1 = QVBoxLayout(None,0,6,"layout1")

        self.textLabel1 = QLabel(self,"textLabel1")
        layout1.addWidget(self.textLabel1)

        self.textEdit1 = QTextEdit(self,"textEdit1")
        self.textEdit1.setWordWrap(QTextEdit.WidgetWidth)
        self.textEdit1.setReadOnly(1)
        layout1.addWidget(self.textEdit1)

        self.textLabel1_2 = QLabel(self,"textLabel1_2")
        textLabel1_2_font = QFont(self.textLabel1_2.font())
        textLabel1_2_font.setPointSize(9)
        self.textLabel1_2.setFont(textLabel1_2_font)
        layout1.addWidget(self.textLabel1_2)

        AboutLayout.addLayout(layout1,0,1)

        layout2 = QVBoxLayout(None,0,6,"layout2")

        self.pixmapLabel5 = QLabel(self,"pixmapLabel5")
        self.pixmapLabel5.setFrameShape(QLabel.NoFrame)
        self.pixmapLabel5.setFrameShadow(QLabel.Plain)
        self.pixmapLabel5.setPixmap(self.image0)
        self.pixmapLabel5.setScaledContents(0)
        layout2.addWidget(self.pixmapLabel5)
        spacer1 = QSpacerItem(21,21,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout2.addItem(spacer1)

        AboutLayout.addLayout(layout2,0,0)

        self.languageChange()

        self.resize(QSize(490,285).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)


    def languageChange(self):
        self.setCaption(self.__tr("About"))
        self.textLabel1.setText(self.__tr("<font size=\"+1\"><b>QTunapie</b></font>"))
        self.textEdit1.setText(self.__tr("Copyright (C) 2006 John\n"
"\n"
"This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.\n"
"\n"
"This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.\n"
"\n"
"You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n"
"\n"
"\n"
"This program is based in Tunapie :\n"
"http://sourceforge.net/projects/tunapie"))
        self.textLabel1_2.setText(self.__tr("Copyright 2005-2006  QTunapie Developer"))


    def __tr(self,s,c = None):
        return qApp.translate("About",s,c)
  
class Preferences(QDialog):
    def __init__(self,parent = None,name = None,modal = 0,fl = 0):
        QDialog.__init__(self,parent,name,modal,Qt.WStyle_Customize | Qt.WStyle_DialogBorder)

        if not name:
            self.setName("Preferences")


 	PreferencesLayout = QGridLayout(self,1,1,11,6,"PreferencesLayout")

        self.groupBox2 = QGroupBox(self,"groupBox2")
        self.groupBox2.setColumnLayout(0,Qt.Vertical)
        self.groupBox2.layout().setSpacing(6)
        self.groupBox2.layout().setMargin(11)
        groupBox2Layout = QVBoxLayout(self.groupBox2.layout())
        groupBox2Layout.setAlignment(Qt.AlignTop)

        self.rdbtn1 = QRadioButton(self.groupBox2,"rdbtn1")
        self.rdbtn1.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.rdbtn1.sizePolicy().hasHeightForWidth()))
        self.rdbtn1.setChecked(1)
        groupBox2Layout.addWidget(self.rdbtn1)

        layout2 = QHBoxLayout(None,0,6,"layout2")

        self.rdbtn2 = QRadioButton(self.groupBox2,"rdbtn2")
        self.rdbtn2.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.rdbtn2.sizePolicy().hasHeightForWidth()))
        layout2.addWidget(self.rdbtn2)

        self.txtplayer = QLineEdit(self.groupBox2,"txtplayer")
        self.txtplayer.setSizePolicy(QSizePolicy(QSizePolicy.Ignored,QSizePolicy.Fixed,0,0,self.txtplayer.sizePolicy().hasHeightForWidth()))
        layout2.addWidget(self.txtplayer)
        groupBox2Layout.addLayout(layout2)

        PreferencesLayout.addMultiCellWidget(self.groupBox2,1,1,0,1)

        self.groupBox1 = QGroupBox(self,"groupBox1")
        self.groupBox1.setColumnLayout(0,Qt.Vertical)
        self.groupBox1.layout().setSpacing(6)
        self.groupBox1.layout().setMargin(11)
        groupBox1Layout = QHBoxLayout(self.groupBox1.layout())
        groupBox1Layout.setAlignment(Qt.AlignTop)

        self.chkadult = QCheckBox(self.groupBox1,"chkadult")
        self.chkadult.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.chkadult.sizePolicy().hasHeightForWidth()))
        groupBox1Layout.addWidget(self.chkadult)

        PreferencesLayout.addMultiCellWidget(self.groupBox1,2,2,0,1)

        layout3 = QVBoxLayout(None,0,6,"layout3")
        spacer1 = QSpacerItem(41,111,QSizePolicy.Minimum,QSizePolicy.Expanding)
        layout3.addItem(spacer1)
	
	image=QPixmap("./icons/filesave.png")
        self.btnSave = QPushButton(QIconSet(image),"",self,"btnSave")
        self.btnSave.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.btnSave.sizePolicy().hasHeightForWidth()))
        layout3.addWidget(self.btnSave)

        PreferencesLayout.addMultiCellLayout(layout3,0,2,2,2)

        layout5 = QHBoxLayout(None,0,6,"layout5")

        self.textLabel1 = QLabel(self,"textLabel1")
        self.textLabel1.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Preferred,0,0,self.textLabel1.sizePolicy().hasHeightForWidth()))
        layout5.addWidget(self.textLabel1)

        self.txtmax = QSpinBox(self,"txtmax")
        self.txtmax.setSizePolicy(QSizePolicy(QSizePolicy.Fixed,QSizePolicy.Fixed,0,0,self.txtmax.sizePolicy().hasHeightForWidth()))
        self.txtmax.setMaxValue(500)
        self.txtmax.setValue(500)
        layout5.addWidget(self.txtmax)
        spacer2 = QSpacerItem(21,20,QSizePolicy.Expanding,QSizePolicy.Minimum)
        layout5.addItem(spacer2)

        PreferencesLayout.addLayout(layout5,0,0)

        self.languageChange()

        self.resize(QSize(334,207).expandedTo(self.minimumSizeHint()))
        self.clearWState(Qt.WState_Polished)

        self.connect(self.btnSave,SIGNAL("clicked()"),self.btnSave_clicked)
        self.connect(self.rdbtn1,SIGNAL("stateChanged(int)"),self.rdbtn1_stateChanged)
        self.connect(self.rdbtn2,SIGNAL("stateChanged(int)"),self.rdbtn2_stateChanged)

        self.setTabOrder(self.txtmax,self.rdbtn1)
        self.setTabOrder(self.rdbtn1,self.rdbtn2)
        self.setTabOrder(self.rdbtn2,self.txtplayer)
        self.setTabOrder(self.txtplayer,self.chkadult)
        self.setTabOrder(self.chkadult,self.btnSave)
	
	self.initialize()

    def languageChange(self):
        self.setCaption(self.__tr("Preferences"))
        self.groupBox2.setTitle(self.__tr("Media Player"))
        self.rdbtn1.setText(self.__tr("VLC"))
        self.rdbtn2.setText(self.__tr("Other :"))
        self.groupBox1.setTitle(self.__tr("Adult"))
        self.chkadult.setText(self.__tr("Adult Filter Content"))
        self.btnSave.setText(self.__tr("Save"))
        self.textLabel1.setText(self.__tr("Max. Number of Streams :"))
	
	###########################################################################3

    def btnSave_clicked(self):
       if self.rdbtn2.isChecked():
	       mplayer=self.txtplayer.text()
       else :
	       mplayer="vlc"
       if self.chkadult.isChecked():
		adult=1
       else :
		adult=0
       tuner.writepreferences(str(self.txtmax.value()),mplayer,adult)
       self.reject() # Close Window
    def rdbtn1_stateChanged(self,a0):
        if self.rdbtn1.isChecked() :
		self.rdbtn2.setChecked(False)
		self.txtplayer.setEnabled(0)

    def rdbtn2_stateChanged(self,a0):
        if self.rdbtn2.isChecked() :
		self.txtplayer.setEnabled(1)
		self.rdbtn1.setChecked(False)

    def __tr(self,s,c = None):
        return qApp.translate("Preferences",s,c)

    def initialize(self):
	self.txtmax.setValue(int(tuner.getmaxdl()))
	if tuner.getmediaplayer() != "vlc":
		self.rdbtn1.setChecked(False)
		self.rdbtn2.setChecked(True)
		self.txtplayer.setText(tuner.getmediaplayer())
	if tuner.getadultfilter()=="1":
		self.chkadult.setChecked(True)
	if self.rdbtn1.isChecked() :
		self.txtplayer.setEnabled(0)


